#!/usr/bin/python
#coding=utf-8
import gtk
import gtk.glade
import os
import sys
import subprocess

###将glade生成的xml文件读取到程序中###########
if os.access("main_policy.glade",os.F_OK):
	xml = gtk.glade.XML("main_policy.glade")
else:
	xml = gtk.glade.XML("/usr/share/sepolicy-tool/main_policy.glade")
def info(message):
	dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO,
			gtk.BUTTONS_OK,
			message)
	dlg.set_position(gtk.WIN_POS_CENTER)
	dlg.show_all()
	rc=dlg.run()
	dlg.destroy()
	return rc

###创建主类
class MainPage():
	def __init__(self):
		self.mainWindow = xml.get_widget("mainWindow")
                self.notebook = xml.get_widget("notebook1")
		self.aboutWindow = xml.get_widget("aboutWindow")
		self.quit_menu = xml.get_widget("quit_menu")

                self.sys_mod_button = xml.get_widget("sys_mod_button")
		self.sys_mod_button.set_relief(gtk.RELIEF_NONE)


                self.user_define_mod_button = xml.get_widget("user_define_mod_button")
		self.user_define_mod_button.set_relief(gtk.RELIEF_NONE)

		self.sys_default_mod_button = xml.get_widget("sys_default_mod_button")
		self.sys_default_mod_button.set_relief(gtk.RELIEF_NONE)

		self.create_mod_button = xml.get_widget("create_mod_button")
		self.create_mod_button.set_relief(gtk.RELIEF_NONE)

		self.history_mod_button = xml.get_widget("history_mod_button")
		self.history_mod_button.set_relief(gtk.RELIEF_NONE)

		self.fixed = xml.get_widget("fixed1")
		self.fixed.connect("expose-event",self.draw_pixbuf)
		
		self.welcome_label = xml.get_widget("label4")
		self.welcome_label.connect("expose-event",self.welcomepage_pixbuf)

		self.sys_default_fixed = xml.get_widget("fixed2")
		self.sys_default_fixed.connect("expose-event",self.sys_default_pixbuf) 

		self.create_pol_fixed = xml.get_widget("fixed3")
		self.create_pol_fixed.connect("expose-event",self.create_pol_pixbuf)
		
		self.menu = xml.get_widget("menubar1")
		
		self.left_bar = xml.get_widget("label6")
		#self.left_bar.connect("expose-event",self.left_bar_pixbuf1)
		path = "/usr/share/sepolicy-tool/image/left-button1.1.png"
		image= gtk.image_new_from_file(path)
		self.sys_mod_button.set_image(image)

		
		path = "/usr/share/sepolicy-tool/image/left-button2.1.png"
		image = gtk.image_new_from_file(path)
		self.user_define_mod_button.set_image(image)

		self.help_button = xml.get_widget("help_button")
	####修改/etc/selinux/mls这个目录的所属用户与组
		os.system("chown -R secadm.secadm /etc/selinux/mls/")

	###创建主界面图片
	def draw_pixbuf(self,widget, event):
	        path = '/usr/share/sepolicy-tool/image/main_UI_1.png'
        	pixbuf = gtk.gdk.pixbuf_new_from_file(path)
        	widget.window.draw_pixbuf(widget.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0, 0,0,0)

	### 显示系统默认按钮时的图片
	def sys_default_pixbuf(self,widget, event):
	        path = '/usr/share/sepolicy-tool/image/system_default.jpg'
        	pixbuf = gtk.gdk.pixbuf_new_from_file(path)
        	widget.window.draw_pixbuf(widget.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0,0,105,175)

	###  策略模块创建按钮时的图片
	def create_pol_pixbuf(self,widget, event):
	        path = '/usr/share/sepolicy-tool/image/create_policy.jpg'
        	pixbuf = gtk.gdk.pixbuf_new_from_file(path)
        	widget.window.draw_pixbuf(widget.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0, 0,105,175)
	
	### 欢迎界面图片
	def welcomepage_pixbuf(self,widget, event):
	        path = '/usr/share/sepolicy-tool/image/welcome.jpg'
        	pixbuf = gtk.gdk.pixbuf_new_from_file(path)
        	widget.window.draw_pixbuf(widget.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0, 0,105,175)


	### 显示系统策略函数
	def show_sys_mod(self,args):
		self.notebook.set_current_page(1)
		if self.notebook.get_current_page() == 1:
			self.sys_mod_button.pressed()

		path = "/usr/share/sepolicy-tool/image/left-button1.1.png"
		image= gtk.image_new_from_file(path)
		self.sys_mod_button.set_image(image)
	
	def show_sys_mod_leave(self,args):
		path = "/usr/share/sepolicy-tool/image/left-button1.2.png"
                image= gtk.image_new_from_file(path)
                self.sys_mod_button.set_image(image)


	### 显示用户自定义策略函数
	def show_user_define(self,args):
		self.notebook.set_current_page(2)
		if self.notebook.get_current_page() == 2:
			self.user_define_mod_button.pressed()
		path = "/usr/share/sepolicy-tool/image/left-button2.2.png"
		image=gtk.image_new_from_file(path)
		self.user_define_mod_button.set_image(image)

	def user_define_mod_button_leave(self,args):
		path = "/usr/share/sepolicy-tool/image/left-button2.1.png"
		image = gtk.image_new_from_file(path)
		self.user_define_mod_button.set_image(image)

	### 点击"系统默认策略"按钮时，触发的动作
	def show_policy_mod_page(self,args):
		os.spawnl(os.P_NOWAIT, "/usr/share/sepolicy-tool/show_sys_policy.py") 
	
	### 点击"创建策略模块"按钮时，触发的动作
	def create_mod_page(self,args): 
		os.spawnl(os.P_NOWAIT, "/usr/share/sepolicy-tool/polgengui.py")

	### 点击"查看模块创建记录"按钮时，触发的动作
	def history_mod_page(self,args):
		os.spawnl(os.P_NOWAIT,"/usr/share/sepolicy-tool/mod_record.py")

	### 帮助按钮显示函数
	def user_help(self,args):
		command = '/usr/bin/evince /usr/share/sepolicy-tool/PolicyTool_manuals.pdf'
		subprocess.Popen(command,stdout=subprocess.PIPE,shell=True)

	### 类主函数
	def main(self):
		self.mainWindow.connect("destroy",gtk.main_quit)

		self.sys_mod_button.connect("enter",self.show_sys_mod)
		self.sys_mod_button.connect("leave",self.show_sys_mod_leave)
		self.user_define_mod_button.connect("enter",self.show_user_define)
		self.user_define_mod_button.connect("leave",self.user_define_mod_button_leave)

		self.sys_default_mod_button.connect("clicked",self.show_policy_mod_page)
		self.create_mod_button.connect("clicked",self.create_mod_page)
		self.history_mod_button.connect("clicked",self.history_mod_page)
		self.help_button.connect("clicked",self.user_help)
		self.mainWindow.show_all()
		gtk.main()

###创建类实例，通过实例调用主函数
if __name__ == "__main__":
	if not os.path.isfile("/var/lib/sepolgen/interface_info"):
        	os.system("/usr/bin/sepolgen-ifgen")

	if not os.path.isdir("/usr/share/sepolicy-tool/lock"):
		os.system("mkdir /usr/share/sepolicy-tool/lock")

	if os.path.isfile("/usr/share/sepolicy-tool/lock/.main.lock"):
		info("安全策略工具主界面已经打开或是存在\
		/usr/share/sepolicy-tool/lock/.main.lock")
		exit(0)
 
	FD=open('/usr/share/sepolicy-tool/lock/.main.lock','a')
	FD.close()
	myapp = MainPage()
	myapp.main()
	os.system('rm -rf /usr/share/sepolicy-tool/lock/.main.lock')


























