#!/usr/bin/python
#coding=utf-8
import signal
import gtk
import gtk.glade
import gnome
import os
import sys
import selinux
import gobject
import polgen

###列出系统已有的策略模块
all_modules = polgen.get_all_modules()
DEL_MOD = 0

###加载glade界面xml文件
if os.access("mod_record.glade",os.F_OK):
	xml = gtk.glade.XML("mod_record.glade")
else:
	xml = gtk.glade.XML("/usr/share/sepolicy-tool/mod_record.glade")

####弹出消息设置
def info(message):
        dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO,
                        gtk.BUTTONS_OK,
                        message)
        dlg.set_position(gtk.WIN_POS_CENTER)
        dlg.show_all()
        rc=dlg.run()
        dlg.destroy()
        return rc


###定义主类
class Modrecord():
	def __init__(self):
		name = ""
		self.mainWindow = xml.get_widget("mainWindow")
		self.view = xml.get_widget("treeview1")
		self.type_button = xml.get_widget("type_button")
		self.add_mod_button =xml.get_widget("add_mod_button")
		self.del_mod_button =xml.get_widget("del_mod_button")
		self.moduleFilter = xml.get_widget("%smoduleFilter"%name)
		liststore = self.type_button.get_model()
                iter = liststore.get_iter_first()
                self.type_button.set_active_iter(iter)
		self.fixed = xml.get_widget("fixed1")
		self.fixed.connect("expose-event",self.draw_pixbuf)

###界面背景图片加载函数
        def draw_pixbuf(self,widget, event):
                path = '/usr/share/sepolicy-tool/image/mod_record.jpg'
                pixbuf = gtk.gdk.pixbuf_new_from_file(path)
                widget.window.draw_pixbuf(widget.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0, 0,0,0)


	def load(self,filter = ""):
		self.filter = filter 
		self.store.clear()
		try:
			fd = os.popen("cat /tmp/installed.log")
			l = fd.readlines()
			fd.close()
			for i in l:
				mod,ver,install_path,mod_cate,create_t,newline  =i.split('\t')
				if not (self.match(mod,filter) or self.match(ver,filter)):
					continue 
				iter  = self.store.append()
				self.store.set_value(iter, 0, mod.strip())
				self.store.set_value(iter, 1, ver.strip())
				self.store.set_value(iter, 2, install_path.strip())
				self.store.set_value(iter, 3, mod_cate.strip())
				self.store.set_value(iter, 4, create_t.strip())
				self.store.set_value(iter, 5, self.semodule_exit(mod.strip()))
		except:
			pass
		self.view.get_selection().select_path((0,))



	def type_load(self,filter = ""):
			
		self.filter = filter 
		self.store.clear()

		liststore = self.type_button.get_model() 
		iter = self.type_button.get_active_iter()
		self.mod_type = liststore.get_value(iter,0)

		#global DEL_MOD
		#if DEL_MOD == 1:
		#	global all_modules
		#	all_modules = polgen.get_all_modules()

		try:
			if not os.path.isfile('/tmp/installed.log'):
				os.system('touch /tmp/installed.log')

			fd = os.popen("cat /tmp/installed.log")
			l = fd.readlines()
			fd.close()
			for i in l:
				mod,ver,install_path,mod_cate,create_t,newline  =i.split('\t')
				if  self.mod_type == mod_cate:
					
					iter  = self.store.append()
					self.store.set_value(iter, 0, mod.strip())
					self.store.set_value(iter, 1, ver.strip())
					self.store.set_value(iter, 2, install_path.strip())
					self.store.set_value(iter, 3, mod_cate.strip())
					self.store.set_value(iter, 4, create_t.strip())
					self.store.set_value(iter, 5, self.semodule_exit(mod.strip()))
			for i in l:
				mod,ver,install_path,mod_cate,create_t,newline  =i.split('\t')
				if  self.mod_type == "全部":
					
					iter  = self.store.append()
					self.store.set_value(iter, 0, mod.strip())
					self.store.set_value(iter, 1, ver.strip())
					self.store.set_value(iter, 2, install_path.strip())
					self.store.set_value(iter, 3, mod_cate.strip())
					self.store.set_value(iter, 4, create_t.strip())
					self.store.set_value(iter, 5, self.semodule_exit(mod.strip()))
			
		except:
			pass

		self.view.get_selection().select_path((0,))

###生成附加策略模块函数	
	def add_mod(self,args):
		store, iter = self.view.get_selection().get_selected()
		policy_dir = store.get_value(iter,0)
		load_or_not = store.get_value(iter,5)

		if os.path.isdir('/tmp/make_policy/'+policy_dir):
			os.chdir('/tmp/make_policy/'+policy_dir)

		if load_or_not == "否":
			info("该策略模块没有加载，无法生成附加策略")
			return 
		
        	os.system("audit2allow -a -M add01")
        	fd = os.popen("cat add01.te")  
        	lines = fd.readlines()
        	fd.close()

###添加附加策略:在原有策略模块的.te文件上添加	
		policy_name=policy_dir+".te"
        	if os.path.isfile(policy_name):        
                	FILE =open(policy_name,'a')
        	else:
                	return 

        	for i in lines:
                	if "#" not in i:
				if  ( policy_dir in i) and  ("auditd_t" not in i) \
                	 or  ("type" in i and "auditd_t" not in i and "auditd_etc_t" not in i) \
                	 or (i[0] == "}") or ("require" in i ) or ("class" in i):
					if len(i)< 200:
						if "security" not in i:
							FILE.write(i)                  
							FILE.write('\n')

        	FILE.close() 
		os.system('rm -rf add01.te')
		if not os.path.isdir("/tmp/policy_log/"):
			os.system('mkdir /tmp/policy_log/')

        	os.system('echo $(date) >> /tmp/policy_log/policy.log')
        	ret = os.system('./policy.sh >>/tmp/policy_log/policy.log')
		os.system('rm -rf add01.pp')
		
		if ret == 0 :
			info("成功生成附加策略并加载")
		else:
			info("生成附加策略失败")

	def del_mod(self,args):
		store, iter = self.view.get_selection().get_selected()
		policy_dir = store.get_value(iter,0)
		load_or_not = store.get_value(iter,5)
		if load_or_not == "是":
			if os.path.isdir("/tmp/make_policy/"+policy_dir+"/port"):
				TCP_PORT_IN="/tmp/make_policy/"+policy_dir+"/port/tcp_in"
				UDP_PORT_IN="/tmp/make_policy/"+policy_dir+"/port/udp_in"
				TCP_PORT_OUT="/tmp/make_policy/"+policy_dir+"/port/tcp_out"
				UDP_PORT_OUT="/tmp/make_policy/"+policy_dir+"/port/udp_out"
				if os.path.isfile(TCP_PORT_IN):
					TCP_PORT_FD=open(TCP_PORT_IN)
					tcp_tmp = TCP_PORT_FD.readline()
					TCP_PORT_FD.close()
					if "-" in tcp_tmp:
						os.system("semanage port -D -r -p tcp "+tcp_tmp)
 
					if ("-" not in tcp_tmp) and (tcp_tmp[0].strip() !=" "):
						os.system("semanage port -d -p tcp "+tcp_tmp)

				if os.path.isfile(UDP_PORT_IN):
					UDP_PORT_FD= open(UDP_PORT_IN)
					udp_tmp = UDP_PORT_FD.readline()
					UDP_PORT_FD.close()
					
					if "-" in udp_tmp:
						os.system("semanage port -D -r -p udp "+ udp_tmp)

					if ("-" not in udp_tmp) and (udp_tmp[0].strip() !=" "):
						os.system("semanage port -d -p udp "+udp_tmp)
					
				if os.path.isfile(TCP_PORT_OUT):
					TCP_PORT_FD=open(TCP_PORT_OUT)
					tcp_tmp = TCP_PORT_FD.readline()
					TCP_PORT_FD.close()
					if "-" in tcp_tmp:
						os.system("semanage port -D -r -p tcp "+tcp_tmp)
 
					if ("-" not in tcp_tmp) and (tcp_tmp[0].strip() !=" "):
						os.system("semanage port -d -p tcp "+tcp_tmp)

				if os.path.isfile(UDP_PORT_OUT):
					UDP_PORT_FD= open(UDP_PORT_OUT)
					udp_tmp = UDP_PORT_FD.readline()
					UDP_PORT_FD.close()
					
					if "-" in udp_tmp:
						os.system("semanage port -D -r -p udp "+ udp_tmp)

					if ("-" not in udp_tmp) and (udp_tmp[0].strip() !=" "):
						os.system("semanage port -d -p udp "+udp_tmp)

			ret = os.system("semodule -r "+policy_dir)
			if ret == 0:
				info("成功删除"+policy_dir+"策略模块")
				global DEL_MOD
				DEL_MOD = 1
				if DEL_MOD == 1:
					global all_modules
					all_modules = polgen.get_all_modules()
				self.load()

		if load_or_not == "否":
			info("该策略模块没有加载，不能删除")
		
				

###判断策略模块是否存在	
	def semodule_exit(self,args):
		if args in all_modules:
			ret = "是"
		else: 
			ret = "否"
		return ret
		
		
	def match(self,target ,filter):
		try:
			f=filter.lower()
			t=target.lower()
			if t.find(f) >= 0:
				return True
		except:
			pass 
		return False
	
	def filter_change(self,*args):
		filter = args[0].get_text()
		if filter != self.filter:
			self.load(filter)
		
###设置主界面函数
	def Setupscreen(self):
		self.store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING,\
		gobject.TYPE_STRING,gobject.TYPE_STRING,gobject.TYPE_STRING)
		self.view.set_model(self.store)
		
		self.store.set_sort_column_id(0, gtk.SORT_ASCENDING)		
		col = gtk.TreeViewColumn("模块名",gtk.CellRendererText(),text=0)
		col.set_sort_column_id(0)
		col.set_resizable(True)
		self.view.append_column(col)

		self.store.set_sort_column_id(1, gtk.SORT_ASCENDING)		
		col = gtk.TreeViewColumn("版本",gtk.CellRendererText(),text=1)
		col.set_sort_column_id(1)
		col.set_resizable(True)
		self.view.append_column(col)

		self.store.set_sort_column_id(2, gtk.SORT_ASCENDING)		
		col = gtk.TreeViewColumn("安装路径",gtk.CellRendererText(),text=2)
		col.set_sort_column_id(2)
		col.set_resizable(True)
		self.view.append_column(col)
		
		self.store.set_sort_column_id(3, gtk.SORT_ASCENDING)		
		col = gtk.TreeViewColumn("策略类型",gtk.CellRendererText(),text=3)
		col.set_sort_column_id(3)
		col.set_resizable(True)
		self.view.append_column(col)
		
		self.store.set_sort_column_id(4, gtk.SORT_ASCENDING)		
		col = gtk.TreeViewColumn("创建时间",gtk.CellRendererText(),text=4)
		col.set_sort_column_id(4)
		col.set_resizable(True)
		self.view.append_column(col)
		
		self.store.set_sort_column_id(5, gtk.SORT_ASCENDING)		
		col = gtk.TreeViewColumn("是否加载",gtk.CellRendererText(),text=5)
		col.set_sort_column_id(5)
		col.set_resizable(True)
		self.view.append_column(col)

		self.load()
###主函数
	def main(self):
		self.Setupscreen()
		self.mainWindow.connect("destroy",gtk.main_quit)
		self.mainWindow.show_all()
		self.moduleFilter.connect("focus_out_event" ,self.filter_change)
		self.moduleFilter.connect("activate",self.filter_change)
		self.type_button.connect("changed",self.type_load)
		self.add_mod_button.connect("clicked",self.add_mod)
		self.del_mod_button.connect("clicked",self.del_mod)
		gtk.main()


if __name__ == "__main__":
	if not os.path.isdir("/usr/share/sepolicy-tool/lock"):
             os.system("mkdir /usr/share/sepolicy-tool/lock")

	if os.path.isfile("/usr/share/sepolicy-tool/lock/.mod_record.lock"):
             info("策略模块创建记录界面已经打开或是存在/usr/share/sepolicy-tool/\
	     lock/.mod_record.lock,如果存在，请把它删除")
             exit(0)
 
        FD=open('/usr/share/sepolicy-tool/lock/.mod_record.lock','a')
	myapp = Modrecord()
	myapp.main()		
	os.system("rm -rf /usr/share/sepolicy-tool/lock/.mod_record.lock")

























