#!/usr/bin/python
#coding=utf-8
#author: shiwei.huang@cs2c.com.cn

import signal
import gtk
import gtk.glade
import gnome
import os
import sys
import selinux
import gobject
import modulesPage 
import string
import statusPage
import booleansPage
import loginsPage
import usersPage
import portsPage
import domainsPage
import fcontextPage
import pygtk
import polgen
from semanagePage import *;

all_modules = polgen.get_all_modules()

if os.access("show_sys_policy.glade",os.F_OK):
	xml = gtk.glade.XML("show_sys_policy.glade")
else:
	xml = gtk.glade.XML("/usr/share/sepolicy-tool/show_sys_policy.glade")

def info(message):
        dlg = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO,
                        gtk.BUTTONS_OK,
                        message)
        dlg.set_position(gtk.WIN_POS_CENTER)
        dlg.show_all()
        rc=dlg.run()
        dlg.destroy()
        return rc


class Myapp():
	def __init__(self):
		name = ""
                self.view = xml.get_widget("treeview1")
		self.mainWindow = xml.get_widget("mainWindow")
		self.aboutWindow = xml.get_widget("aboutWindow")
		self.quit_menu = xml.get_widget("quit_menu")
		self.type_button = xml.get_widget("type_combo")
		self.moduleFilter = xml.get_widget("%smoduleFilter"%name)
		self.fixed = xml.get_widget("fixed2")
		self.check = gtk.CheckButton('Check to disable view tooltips')
		self.tooltips = gtk.Tooltip()
		self.fixed.connect("expose-event",self.draw_pixbuf)
		self.view.connect("motion-notify-event",self.cell_tooltips)


		self.type_button.set_sensitive(True)
                liststore = self.type_button.get_model()
                iter = liststore.get_iter_first()
                self.type_button.set_active_iter(iter)

	def cell_tooltips(self,args,sec):
		store, iter = self.view.get_selection().get_selected()
                show_info = store.get_value(iter,2)

		tt = gtk.Tooltips()
    		tt.set_tip(self.view, (show_info))		
		
	def draw_pixbuf(self,widget, event):
                path = '/usr/share/sepolicy-tool/image/show_sys_mod.jpg'
                pixbuf = gtk.gdk.pixbuf_new_from_file(path)
                widget.window.draw_pixbuf(widget.style.bg_gc[gtk.STATE_NORMAL], pixbuf, 0, 0,0,0)


	def match(self, target, filter):
		try:
			f=filter.lower()
		     	t=target.lower()
		     	if t.find(f) >= 0:
				 return True
		except:
		    pass
		return False

	def type_match(self,args):
		liststore = self.type_button.get_model()
		iter = self.type_button.get_active_iter()
		self.mod_type = liststore.get_value(iter,0)
		return self.mod_type	
	
			
	def load(self, filter=""):
		global all_modules

		self.filter=filter    
		self.store.clear()
		getmod_type = self.type_match

		try:
		    fd=os.popen('cat /usr/share/sepolicy-tool/policy_cate_sys.txt.1')
		    l = fd.readlines()
		    fd.close()
		    for i in l:
			module, ver, modinfo, install_path, mod_type, newline  = i.split('\t')
			if not (self.match(module, filter) or self.match(ver, filter) or \
				(mod_type == getmod_type)):
			    continue

			if module.strip() in all_modules:
				iter = self.store.append()
				self.store.set_value(iter, 0, module.strip())
				self.store.set_value(iter, 1, ver.strip())
				self.store.set_value(iter, 2, modinfo.strip())
				self.store.set_value(iter, 3, install_path.strip())
				self.store.set_value(iter, 4, mod_type.strip())
		except:
		    pass
		self.view.get_selection().select_path ((0,))

	def type_load(self, filter=""):
		global all_modules

		self.filter=filter    
		self.store.clear()
				
		liststore = self.type_button.get_model()
		iter = self.type_button.get_active_iter()
		self.mod_type = liststore.get_value(iter,0)

		try:
		    fd=os.popen('cat /usr/share/sepolicy-tool/policy_cate_sys.txt.1')
		    l = fd.readlines()
		    fd.close()
		    for i in l:
			module, ver, modinfo, install_path, mod_type, newline  = i.split('\t')
			if  (self.mod_type == "全部") and ( module.strip() in all_modules):
		
			    iter = self.store.append()
			    self.store.set_value(iter, 0, module.strip())
			    self.store.set_value(iter, 1, ver.strip())
			    self.store.set_value(iter, 2, modinfo.strip())
			    self.store.set_value(iter, 3, install_path.strip())
			    self.store.set_value(iter, 4, mod_type.strip())

		    for i in l:
		       module, ver, modinfo, install_path, mod_type, newline  = i.split('\t')
		       if  (self.mod_type == mod_type) and (module.strip() in all_modules):

		          iter = self.store.append()
		          self.store.set_value(iter, 0, module.strip())
		          self.store.set_value(iter, 1, ver.strip())
		          self.store.set_value(iter, 2, modinfo.strip())
		          self.store.set_value(iter, 3, install_path.strip())
		          self.store.set_value(iter, 4, mod_type.strip())

		except:
		    pass
		self.view.get_selection().select_path ((0,))


	def Setupscreen(self):

		self.store = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING,\
		gobject.TYPE_STRING,gobject.TYPE_STRING)
                self.view.set_model(self.store)
	
                self.store.set_sort_column_id(0, gtk.SORT_ASCENDING)
                #col = gtk.TreeViewColumn(_("Module Name"), gtk.CellRendererText(), text = 0)
                col = gtk.TreeViewColumn(("模块名"), gtk.CellRendererText(), text = 0)
                col.set_sort_column_id(0)
                col.set_resizable(True)
		self.view.append_column(col)

		self.store.set_sort_column_id(1, gtk.SORT_ASCENDING)
		col = gtk.TreeViewColumn(_("Version"), gtk.CellRendererText(), text = 1)
		col.set_sort_column_id(1)
                col.set_resizable(True)
		self.view.append_column(col)

		self.store.set_sort_column_id(2,gtk.SORT_ASCENDING)
		self.col= col = gtk.TreeViewColumn(("模块简介"),gtk.CellRendererText(),text = 2)
		col.set_sort_column_id(2)
		col.set_max_width(250)
                #col.set_resizable(True)
		self.view.append_column(col)
		
		self.store.set_sort_column_id(3,gtk.SORT_ASCENDING)
		col = gtk.TreeViewColumn(("安装路径"),gtk.CellRendererText(),text = 3)
		col.set_sort_column_id(3)
                col.set_resizable(True)
		self.view.append_column(col)

		self.store.set_sort_column_id(4,gtk.SORT_ASCENDING)
		col = gtk.TreeViewColumn(("模块类型"),gtk.CellRendererText(),text = 4)
		col.set_sort_column_id(4)
                col.set_resizable(True)
		self.view.append_column(col)

		self.load()

		
	def on_about(self,args):
		dlg = xml.get_widget ("aboutdialog1")
		dlg.run()
		dlg.hide()

	def filter_change(self,*args):
		filter=args[0].get_text()
		if filter != self.filter:
                	self.load(filter)

	def main(self):
		self.Setupscreen()
		self.mainWindow.connect("destroy",gtk.main_quit)
		#self.aboutWindow.connect("activate",self.on_about)
		#self.quit_menu.connect("activate",gtk.main_quit)
		self.moduleFilter.connect("focus_out_event",self.filter_change)
		self.moduleFilter.connect("activate",self.filter_change)
		self.type_button.connect("changed",self.type_load)
		self.mainWindow.show_all()
		gtk.main()

if __name__ == "__main__":
	if not os.path.isdir("/usr/share/sepolicy-tool/lock"):
        	os.system("mkdir /usr/share/sepolicy-tool/lock")

	if os.path.isfile("/usr/share/sepolicy-tool/lock/.show_sys_mod.lock"):
        	info("显示策略模块界面已经打开或是存在/usr/share/sepolicy-tool/lock/.show_sys_mod.lock\
		如果存在，则删除")
        	exit(0)
 
        FD=open('/usr/share/sepolicy-tool/lock/.show_sys_mod.lock','a')
        FD.close()

	myapp = Myapp()
	myapp.main()
	os.system('rm -rf /usr/share/sepolicy-tool/lock/.show_sys_mod.lock')

























